function x=UTriSol(U,y)
%
% Input:
%   U   nxn (matrice triangolare superiore non singolare)
%   y   nx1 (termine noto del sistema lineare) 
%
% Output:
%   x   nx1 (soluzione del sistema lineare Ux = Y) 


%Prima verisone
n=length(y);
x=zeros(n,1);
x(n)=y(n)/U(n,n);
for k=n-1:-1:1
    somma=0.0;
    for j=k+1:n
        somma=somma+U(k,j)*x(j);
    end
    x(k)=(y(k)-somma)/U(k,k);
end

%Versione alternativa
%n=length(y);
%x=zeros(n,1);
%for j=n:-1:2
%    x(j)=y(j)/U(j,j);
%    y(1:j-1)=y(1:j-1)-x(j)*U(1:j-1,j);
%end
%x(1)=y(1)/U(1,1);
